# Geo

- [GitLab Environment Toolkit - Quick Start Guide](../environment_quick_start_guide.md)
- [GitLab Environment Toolkit - Preparing the environment](../environment_prep.md)
- [GitLab Environment Toolkit - Provisioning the environment with Terraform](../environment_provision.md)
- [GitLab Environment Toolkit - Configuring the environment with Ansible](../environment_configure.md)
- [GitLab Environment Toolkit - Advanced - Custom Config / Tasks / Files, Data Disks, Advanced Search, Container Registry and more](../environment_advanced.md)
- [GitLab Environment Toolkit - Advanced - Cloud Native Hybrid](../environment_advanced_hybrid.md)
- [GitLab Environment Toolkit - Advanced - Component Cloud Services / Custom (Load Balancers, PostgreSQL, Redis)](../environment_advanced_services.md)
- [GitLab Environment Toolkit - Advanced - SSL](../environment_advanced_ssl.md)
- [GitLab Environment Toolkit - Advanced - Network Setup](../environment_advanced_network.md)
- [GitLab Environment Toolkit - Advanced - Monitoring](../environment_advanced_monitoring.md)
- [GitLab Environment Toolkit - Upgrades (Toolkit, Environment)](../environment_upgrades.md)
- [GitLab Environment Toolkit - Considerations After Deployment - Backups, Security](../environment_post_considerations.md)
- [GitLab Environment Toolkit - Geo](README.md)
  - [GitLab Environment Toolkit - Geo - Provisioning the environment with Terraform](geo_provision.md)
  - [GitLab Environment Toolkit - Geo - Configuring the environment with Ansible](geo_configure.md)
  - [**GitLab Environment Toolkit - Geo - Advanced**](geo_advanced.md)
- [GitLab Environment Toolkit - Troubleshooting](../environment_troubleshooting.md)

[[_TOC_]]

## Custom Servers with Geo (On Prem)

On Prem servers are supported by the toolkit, details on how to work with On Prem servers can be found in our [Custom Servers (On Prem)](../environment_advanced.md#custom-servers-on-prem) documentation.

## Unified URLs

When using a Unified URL for Geo you will need to read the documentation on how to [set up a unified URL for Geo sites](https://docs.gitlab.com/ee/administration/geo/secondary_proxy/index.html#set-up-a-unified-url-for-geo-sites) and follow the process for [configuring location-aware DNS](https://docs.gitlab.com/ee/administration/geo/secondary_proxy/index.html#configure-location-aware-dns).

To use a single unified URL to access the primary and secondary sites with the Toolkit you will first need to ensure you have 3 unique URLs available.

- Unified URL: This is a geo-based URL that will be used to route traffic to either site based on the users location.
- Primary URL: This is a URL that will always route traffic to the primary site.
- Secondary URL: This is a URL that will always route traffic to the secondary site.

 With the URLs setup you will now need to change a few settings within your inventories to enable this feature.

```yaml
external_url: "<Unified URL>"
geo_primary_external_url: "<Unified URL>"
geo_secondary_external_url: "<Unified URL>"
geo_primary_internal_url: "<Primary URL>"
geo_secondary_internal_url: "<Secondary URL>"

# When using the Container Registry
# The Registry URL should always resolve to the primary site.
geo_primary_registry_url: "registry.<Unified URL>"

# Cloud Native environments only
external_geo_ip: "<IP Address for geo_secondary_internal_url>"
cloud_native_hybrid_geo_unified_url: true
```

### SSL

To use [certificates generated by Let's Encrypt](../environment_advanced_ssl.md#lets-encrypt-generated-certificates) with a unified URL, additional setup is required.

Let's Encrypt should be configured on the Primary site as normal, but for the Secondary site the same certificate is required. As such, you'll need to manually download the generated certificates from your primary site and then set your secondary site's inventory to use them as [user provided certificates](../environment_advanced_ssl.md#user-provided-certificates).

For Linux package installs, if using the Toolkit provided HAProxy load balancers, then the certificates can be found in `/opt/haproxy` on the HAProxy external node. For Cloud Native Hybrid environments, the following commands can be used to get the contents of each file from the primary site, you can then save them locally.

```sh
kubectl get secrets gitlab-gitlab-tls -o jsonpath --template '{.data.tls\.crt}' | base64 --decode
kubectl get secrets gitlab-gitlab-tls -o jsonpath --template '{.data.tls\.key}' | base64 --decode
```

## Failover and Recovery

Before starting the failover or recovery process, the Toolkit will enable [Maintenance Mode](https://docs.gitlab.com/ee/administration/maintenance_mode/index.html). When enabling maintenance mode, a message can be set that will appear in a banner at the top of the site.

- `maintenance_mode_message` - Sets the message to be displayed in a banner at the top of the page. Defaults to "GitLab is undergoing maintenance".

After the failover or recovery process has completed, maintenance mode will be disabled.

### Failover

> The Toolkit automated Geo failover process is available for Geo deployments running GitLab versions 14.2 or above.

The Toolkit provides the ability to failover from a Geo primary site to a secondary site. This process will disable the current primary site and promotes the secondary site to be a standalone GitLab instance.

Before running the failover process you should ensure you have read and completed any required steps outlined in the [Disaster recovery for planned failover](https://docs.gitlab.com/ee/administration/geo/disaster_recovery/planned_failover.html) documentation.

Once you get to the [Promote the secondary site](https://docs.gitlab.com/ee/administration/geo/disaster_recovery/planned_failover.html#promote-the-secondary-site) step in the documentation you can proceed to perform a failover. To do the failover you can use the existing inventories to disable the primary and promote the secondary in a single command `ansible-playbook -i environments/my-geo-deployment/<secondary>/inventory -i environments/my-geo-deployment/<primary>/inventory playbooks/gitlab_geo_failover.yml`. If using multiple secondaries you will need to choose a single secondary that will be promoted to a stand a lone instance until recovery is run.

After failover has occurred it's important to update your inventories to reflect the new roles they now perform and to avoid misconfiguration on subsequent runs. The original primary and secondary inventories need updating. For all environment types you will need to update the settings mentioned in the [Adding Geo specific config](geo_configure.md) section.

Finally, if using AWS RDS or GCP Cloud SQL, in the Terraform config for the original secondary site you will need to remove the `rds_postgres_replication_database_arn` or `cloud_sql_postgres_master_instance_name` variables respectively to prevent any misconfiguration happening on the next Terraform run.

### Recovery

After a failover has been performed it's then possible to take the old Geo primary site and turn it into a secondary. This will attach the old primary to the new primary site and begin the replication process. For a planned failover this could occur as soon as the new primary has been promoted, for an unplanned failover the old primary site should be checked for any issues before performing this step.

Before performing a recovery the inventories must be updated to reflect each site's new roles.

Once done you can perform the recovery process by running the command `ansible-playbook -i environments/my-geo-deployment/secondary/inventory -i environments/my-geo-deployment/<primary>/inventory playbooks/gitlab_geo_recovery.yml`

### AWS RDS

The failover and recovery process when using RDS is largely the same as the standard process. However it will also require the use of Terraform.

:information_source:&nbsp; Before running `terraform apply` it is advised to check the output of `terraform plan` and ensure that all changes are expected.

#### Failover

To perform a failover the following terraform settings will need to be updated for the site that will be promoted:

- Set `rds_postgres_replication_database_arn` to `null`.
- Set `rds_postgres_password` to your Postgres password.
- Set `rds_postgres_backup_retention_period` to a value between 0 and 35.

Terraform will complete straight away, however the process can take a few minutes to complete within AWS, you will need to wait for the database to show as `Available` in AWS before continuing. Once completed, the following additional settings will need to be updated in Ansible and then the failover process can be followed as normal:

- `postgres_host`
- `geo_secondary_postgres_host`
- `geo_secondary_praefect_postgres_host`
- `geo_tracking_postgres_host`

#### Recovery

The RDS recovery process involves deleting the old primary RDS instance, this is done by removing the `rds_postgres_instance_type` setting from the `environment.tf` file for the site currently being recovered and running `terraform apply`. Once deleted, Add the `rds_postgres_instance_type` setting back into `environment.tf` along with the following settings:

- Set `rds_postgres_replication_database_arn` to the ARN for the new primary site.
- Set `rds_postgres_kms_key_arn` to the KMS key used for the primary site's RDS instance.
- Remove `rds_postgres_password`.
- Remove `rds_postgres_backup_retention_period`.

### GCP Cloud SQL

The failover and recovery process when using Cloud SQL is largely the same as the standard process. However it will also require the use of Terraform.

:information_source:&nbsp; Before running `terraform apply` it is advised to check the output of `terraform plan` and ensure that all changes are expected.

#### Failover

To perform a failover the following Terraform settings will need to be updated for the secondary site that will be promoted:

- Set `cloud_sql_postgres_master_instance_name` to `null`.
- Ensure `cloud_sql_postgres_root_password` has **not** been set. The password will already be in place for the replica and attempting to set again triggers a clash on the Cloud Provider. This can be set again as desired _after_ the replica has promoted accordingly.

Terraform will take a few moments to complete and the replica should now be promoted to be its own independent instance. Once completed, the following additional settings will need to be updated in Ansible and then the failover process can be followed as normal:

- `postgres_host`
- `geo_secondary_postgres_host`
- `geo_secondary_praefect_postgres_host`
- `geo_tracking_postgres_host`

#### Recovery

The Cloud SQL recovery process involves deleting the old primary Cloud SQL instance, this is done by removing the `cloud_sql_postgres_machine_tier` setting from the `environment.tf` file for the site currently being recovered and running `terraform apply`. Once deleted, Add the `cloud_sql_postgres_machine_tier` setting back into `environment.tf` along with the following settings:

- Set `cloud_sql_postgres_master_instance_name` to the ARN for the new primary site.
- Remove `cloud_sql_postgres_root_password`.

## Container Registry Replication

The Toolkit configures the [GitLab Container Registry](https://docs.gitlab.com/ee/user/packages/container_registry/) as documented in [Container Registry (GCP, AWS)](../environment_advanced.md#container-registry-gcp-aws) section.

To enable [Container Registry replication](https://docs.gitlab.com/ee/administration/geo/replication/container_registry.html#configure-container-registry-replication) some additional settings are required as follows in Ansible via the [Environment `vars.yml` file](../environment_configure.md#environment-config-varsyml):

- `geo_container_registry_notification_secret` (Primary and Secondary) - Secret value for the container registry authorization header and for the Geo event notification endpoint to use. Value should be set to the same value that is a case-sensitive alphanumeric string on both Primary and Secondary sites.
- `geo_primary_registry_url` - The Primary site's Registry URL. When using the default on the primary this will be `https://registry.<geo_primary_external_host>`.

## Migrating from an external Primary Site using Geo

This section details how to setup Geo replication when the primary site is an external resource that is not provisioned by the Toolkit. This guide is intended to be used when migrating from a non Toolkit provisioned environment to a new instance that will be managed by the Toolkit. In this scenario, Geo is the mechanism to transfer data from one instance to another and is not intended to be used as a standard Geo deployment.

### Prerequisites

Firstly, the standard [Geo Prerequisites](https://docs.gitlab.com/ee/administration/geo/setup/#prerequisites) must be followed before continuing with this guide. For the purposes of this guide, the primary site must be the non Toolkit provisioned environment with a new environment having been created with the Toolkit to act as a secondary. For the secondary site, the [Toolkit Geo documentation](README.md) should still be followed up to the point of preparing to run the `gitlab_geo.yml` playbook, but refrain from actually running the playbook yet.

#### Communication

The two sites must be able to communicate with each other over a secure network that will need to be setup manually.

#### Secrets

During the setup of Geo some secrets are copied over from the primary site to the secondary site, the format of the secrets can differ depending on if you are migrating from a Linux Package or Cloud Native Hybrid installation, the below secrets will need to be manually downloaded from the primary site:

- [PostgreSQL server.crt](https://docs.gitlab.com/ee/administration/geo/setup/database.html#postgresql-replication)
- Linux Package
  - [gitlab-secrets.json](https://docs.gitlab.com/ee/administration/geo/replication/configuration.html#step-1-manually-replicate-secret-gitlab-values)
  - [gitlab-registry.key](https://docs.gitlab.com/ee/administration/geo/replication/container_registry.html) - Only required if using the container registry
  - [SSH Host keys](https://docs.gitlab.com/ee/administration/geo/replication/configuration.html#step-2-manually-replicate-the-primary-sites-ssh-host-keys)
- [Cloud Native Hybrid](https://docs.gitlab.com/charts/advanced/geo/#copy-secrets-from-the-primary-site-to-the-secondary-site)
  - `gitlab-gitlab-shell-host-keys`
  - `gitlab-rails-secret`
  - `gitlab-registry-secret`

#### Gitaly Storage Paths

The [repository storage paths](https://docs.gitlab.com/ee/administration/repository_storage_paths.html) of Gitaly, also known as `git_data_dirs`, is required to match between two Geo sites. As such this means that the environment you are looking to migrate from will need to match the default structure the Toolkit creates.

:information_source:&nbsp; If you have not configured anything specific with repository storage paths or [weights](https://docs.gitlab.com/ee/administration/repository_storage_paths.html#configure-where-new-repositories-are-stored) then all of your repositories will be on the required `default` storage path and no further action will be required.

:information_source:&nbsp; If you think this does apply, it's strongly recommended to raise a Support ticket or engage Professional Services for more guided assistance as this can be complex and involves moving data.

For reference, the Toolkit follows the documentation [defaults](https://docs.gitlab.com/ee/administration/gitaly/) and sets up the following:

- [Gitaly Cluster](https://docs.gitlab.com/ee/administration/gitaly/praefect.html#gitlab) - One `default` path as per Cluster design only with Praefect replicating this path accordingly across all Gitaly nodes.
- [Gitaly Sharded](https://docs.gitlab.com/ee/administration/gitaly/configure_gitaly.html) - `default` path on primary Gitaly node and a `storageX` path on each Gitaly node (where X is the number of the Gitaly node). Note however that the [default GitLab weighting](https://docs.gitlab.com/ee/administration/repository_storage_paths.html#configure-where-new-repositories-are-stored) for this setup targets `default` only unless configured otherwise.

If you have previously changed the repository storage paths or weights from the default settings, additional actions will be required to adjust this to match the environment the Toolkit will create as follows:

- Custom Repository Storage Paths - Repositories created on a custom storage path will need to be [migrated](https://docs.gitlab.com/ee/administration/operations/moving_repositories.html#moving-data-in-a-gitlab-instance) back to the `default` storage path before enabling Geo. If on a Sharded set up repositories could also be moved to a `storageX` if they exist, however in most cases migrating everything to `default` will be the easiest action unless there are any very large repos that could cause disk space issues.
- Adjusted Repository Storage Weights (Sharded only) - If you have followed the documentation and created a `storageX` path on each Gitaly Shard then this can be matched on the Toolkit environment. Proceed to create the environment as normal and then login and adjust the weights to match the existing environment exactly.

### Configuring the Primary Site

As the primary site is not managed by the Toolkit, you'll need to follow the [Setting up Geo](https://docs.gitlab.com/ee/administration/geo/setup/) documentation, following the steps for the primary site.

### Configuring the Secondary Site

The below settings will need to be added to the secondary sites inventory:

- `geo_primary_secrets_file` - Path to the downloaded primary sites `gitlab-secrets.json`, can be provided instead of `geo_primary_secrets_json`.
- `geo_primary_secrets_json` - Contents of the downloaded primary sites `gitlab-secrets.json`, can be provided instead of `geo_primary_secrets_file`.
- `geo_primary_psql_crt_file` - Path to the downloaded primary sites PostgreSQL `server.crt`.
- `geo_primary_postgres_host` - IP address for the Patroni leader / PostgreSQL host.
- `geo_primary_is_multi_node` - Set to `true` if primary site is multi node (2k+).
- `geo_primary_postgres_is_ha` - Set to `true` if primary site is using Patroni for PostgreSQL replication and HA (3k+).
- `geo_primary_registry_url` - The Primary site's Container Registry URL for replication.
- `geo_primary_postgres_count` - The number of Patroni nodes present on the primary site.

#### Linux Package

The below settings are only required when migrating to a Linux Package installation:

- `geo_primary_ssh_host_keys_folder` - Path to a folder that contains the downloaded primary sites ssh host keys.
- `geo_primary_registry_key_file` - Path to the downloaded primary sites `gitlab-registry.key`, only required if using the container registry.

#### Cloud Native Hybrid

The below settings are only required when migrating to a Cloud Native Hybrid installation:

- `geo_primary_ssh_host_keys` - A dictionary of SSH host keys and values to be used as the Chart's SSH Host Keys secret.
- `geo_primary_registry_keys` - A dictionary of the registry `.crt` and `.pem` files to be used as the Chart's Registry authentication certificate, only required if using the Container Registry.

:information_source:&nbsp; Note that these values should be base-64 encoded representations of the file contents. For example: `cat ssh_host_ecdsa_key | base64`.

:exclamation:&nbsp; These are sensitive variables. It's strongly recommended taking appropriate precautions to avoid leaking secrets such as using [secret managers or environment variables](../environment_configure.md#sensitive-variable-handling-in-ansible).

```yml
geo_primary_ssh_host_keys: {
  ssh_host_ecdsa_key: '',
  ssh_host_ecdsa_key.pub: '',
  ssh_host_ed25519_key: '',
  ssh_host_ed25519_key.pub: '',
  ssh_host_rsa_key: '',
  ssh_host_rsa_key.pub: ''
}

geo_primary_registry_keys: {
  registry-auth.crt: '',
  registry-auth.key: ''
}
```

### Running Geo

Once the secrets have been downloaded and the secondary site's inventory updated, you can then run the `gitlab_geo.yml` playbook with the below command to setup the secondary site.

```bash
ansible-playbook -i <secondary inventory> playbooks/gitlab_geo.yml -t secondary
```

Once completed, you will need to follow the steps to [Add the secondary site](https://docs.gitlab.com/ee/administration/geo/setup/two_single_node_sites.html#add-the-secondary-site) to the primary site, starting from step 4 `Navigate to the primary node GitLab instance`. If using [GitLab-managed object storage replication](https://docs.gitlab.com/ee/administration/geo/replication/object_storage.html#enabling-gitlab-managed-object-storage-replication) then you will also need to enable this now on the primary site.

Once complete, if migrating to a Linux Package installation, you'll need to restart the GitLab Rails/Sidekiq nodes on the primary and secondary sites, for the secondary site you can run the below command:

```bash
ansible-playbook -i <secondary inventory> playbooks/gitlab_geo.yml -t workhorse
```

## Multiple Geo Secondary Sites

When setting up Geo secondary sites it is possible to add more than one secondary to a primary site. For environments based on the 1k or 2k reference architectures, replication will be managed by PostgreSQL. When adding a new secondary site you will need to add `geo_secondary_site_count` to your primary sites inventory. This needs to be set to the number of secondary sites that will be attached to the primary site. This defaults to 1 and only needs to be updated when adding more than 1 secondary site.

For environments based on reference architectures 3k+, replication is handled by Patroni. When adding a new secondary site you will need to add/update the below settings in the primary site as well as the new secondary site.

:information_source:&nbsp; The below settings are only required when adding new secondary sites when the database is being managed by GitLab. For external databases, replication would be set up externally.

### Primary site settings

- `geo_secondary_site_count` - The number of secondary sites that will be connected to the primary site. Defaults to 1.
- `geo_primary_replication_slots` - A list of replication slot names. Each secondary site requires a unique slot name for replication. Defaults to `["geo_secondary"]`.

### Secondary site settings

- `geo_primary_slot_name` - The replication slot to use for replication. This should match one of the values in `geo_primary_replication_slots`. Defaults to `"geo_secondary"`.

For all reference architecture sizes, once the primary and secondary inventories have been updated, follow the normal [Geo process](./README.md) for adding a secondary site.

:information_source:&nbsp; You will need to run the Geo playbook for each Geo secondary and should not add all secondaries into 1 command.
